function output = DDisMI(data, C, lambda, numFeature)

fprintf('DDIsMI started...\n');
[~, dim] = size(data);

if (nargin < 4)
   numFeature=dim;
end;

numFeature = min(numFeature, dim);

nodesNum = int32((dim / numFeature) ^ 0.5);

r = randi([1 nodesNum], 1, dim);

nodesFeatures = cell(1,nodesNum);
nodesSelectedFeatures = zeros(nodesNum, numFeature);

for i = 1:nodesNum
  nodesFeatures{i} = [];
end

for i = 1:dim
  nodesFeatures{r(i)} = [nodesFeatures{r(i)}, i];
end

selectedFeaturesPhase1 = [];
for i = 1:nodesNum
    disp(['Node ', num2str(i), '/', num2str(nodesNum), ' running']);
    nodesSelectedFeatures(i, :) = greedy(data(:, r == i), C, lambda, numFeature);
    selectedFeaturesPhase1 = [selectedFeaturesPhase1, nodesFeatures{i}(nodesSelectedFeatures(i,:))];
end

disp(['Master node running']);
finalSelected = greedy(data(:, selectedFeaturesPhase1), C, lambda, numFeature);

output = selectedFeaturesPhase1(finalSelected);

end
