function output = greedy(data, C, lambda, numFeature)

fprintf('Greedy started...\n');
[~, dim] = size(data);

if (nargin < 4)
   numFeature=dim;
end;

numFeature = min(numFeature, dim);

MI = zeros(1, dim);
for i = 1:dim
    MI(i) = nmi(squeeze(data(:,i)), C);
end

dis = zeros(1,dim);
output = zeros(1,numFeature);
selected = false(1,dim);
selected_count = 0;

MI = (1 - lambda) * MI / 2;

while selected_count < numFeature
    
    unselected=~selected;
    
    if selected_count == 0
        if lambda == 1
            thisRoundSelection = 1;
        else
            [~, thisRoundSelection] = max(MI);
        end
    else
        tempScore=(MI+dis/selected_count) .* unselected;
        [~,thisRoundSelection]=max(tempScore);
    end
    
    selected(thisRoundSelection)=true;
    selected_count = selected_count + 1;
    
    counterTemp = 1;
    NVIunselected = zeros(1, sum(unselected));
    
    for i = 1:length(unselected)
        if (unselected(i) == 1)
            NVIunselected(1, counterTemp) = 1 - mutualInformation(data(:, thisRoundSelection), data(:, i)) / jointEntropy(data(:, thisRoundSelection), data(:, i));
            counterTemp = counterTemp + 1;
        end
    end
    
    dis(unselected) = dis(unselected) + lambda * NVIunselected;
    output(selected_count)=thisRoundSelection;
end

end